#include <iostream>
#include <algorithm>
#define Nmax 75001
using namespace std;
int nzd (int a,int b)
{
    if (b==0) return a;
    a=a%b;
    return nzd(b,a);
}
long long a[Nmax],b[Nmax];
int main()
{   int t;
    cin>>t;
    int n[75001],m[75001];
    int k;
    int g;
    int j;
    int l;
    int x;
    int o=0;
    int r[6];
    int p=1;
    for(int k=1;k<=t;k++){
    cin>>n[k]>>m[k];
    for( j=1;j<=n[k];j++) cin>>a[j];
    for( l=1;l<=m[k];l++) cin>>b[l];
    sort(a,a+j);
    x=a[2]-a[1];
    r[k]=1;
    for(g=3;g<=j;g++){
    if(a[g]%x==a[1]) {o++;
     r[k]=1;}
    else r[k]=0;break;
    }
    for(g=1;g<=l;g++){
    if(b[g]%x==a[1]) r[k]=0;
    }

    }
    for(int i=1;i<=t;i++){
    cout<<r[i]<<endl;
    }
    return 0;
}